<?php
	/*
	Plugin Name: Plum Code Box
	Plugin URI: http://www.codeplum.com/wordpress-plugins
	Description: Plum Code Box makes it easy to insert and manage code blocks on a website using the Chili javascript syntax highlighter.
	Version: 1.0
	Author: James Thompson
	Author URI: http://codeplum.com
	License: GPL2
		Copyright 2011  Glen Allsopp  (email : hq@viperchill.com)
	
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License, version 2, as 
		published by the Free Software Foundation.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	*/
	
	if (!class_exists("Plum_Code_Box")) {
		class Plum_Code_Box {
			var $plugin_name;
			var $options_name;
			var $plugin_dir;
			
			function activate() {
				//we don't need to do anything.
			}
			
			function Plum_Code_Box() { //constructor
				$this->plugin_name = "Plum_Code_Box";
				$this->options_name = $this->plugin_name."_options";
				$this->plugin_dir = str_replace("/".basename(__FILE__),"",plugin_basename(__FILE__));
			}
			
			function go() {
				//nothing still.
			}
			
			function add_menu() {
				add_options_page(
					$this->plugin_name." Options",
					$this->plugin_name,
					"manage_options",
					$this->plugin_name,
					array(&$this, 'options_menu')
				);
			}
			
			function add_post_meta_boxes() {
				add_meta_box('Plum_Code_Box','Plum Code Box',array(&$this, 'menu_post_meta'),'post');
				add_meta_box('Plum_Code_Box','Plum Code Box',array(&$this, 'menu_post_meta'),'page');
			}
			
			function menu_post_meta() {
				require("menu_admin_post.php");
			}
			
			function save_post_meta_boxes($post_id) {
				if (!wp_verify_nonce($_POST["Plum_Code_Box_nonce"], "Plum_Code_Box"))
					return $post_id;
					
				if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) 
					return $post_id;
					
				if ( 'page' == $_POST['post_type'] ) {
					if (!current_user_can( 'edit_page', $post_id))
						return $post_id;
				} else {
					if (!current_user_can( 'edit_post', $post_id))
						return $post_id;
				}
				
				foreach($_POST as $key => $value) {
					if(substr($key,0,strlen("Plum_Code_Box_")) == "Plum_Code_Box_" && $key != "Plum_Code_Box_nonce") {
						$data = $value;
						
						if($value != "" || ($value == "" && get_post_meta($post_id, $key) != "")) {
							update_post_meta($post_id, $key, $value);
						}
					}
				}
				
				return true;
			}
			
			function insert_code($content) {
				global $id;
				
				for($i = 1; $i <=10; $i++) {
					$code = get_post_meta($id, "Plum_Code_Box_code_".$i."_code");
					$type = get_post_meta($id, "Plum_Code_Box_code_".$i."_type");
					
					if($code[0] != "") {
						$code_insert =
							"<p>
								<pre style=\"overflow: auto; border: 1px solid #AAAAAA; padding: 3px; font-size: 10px; background: #FFFFFF; margin-left: 20px;\">".
									"<code class=\"".$type[0]."\">".
									str_replace("\t","  ",htmlspecialchars(stripslashes($code[0]))).
									"</code>
									</pre>
							</p>";
						
						if(strpos($content, "[codebox ".$i."]")) {
							$content = str_replace("[codebox ".$i."]",$code_insert,$content);
						}
					}
				}
				
				return $content;
			}
		}
	} //End Class ViperBar
	
	if (class_exists("Plum_Code_Box")) {
		$Plum_Code_Box = new Plum_Code_Box();
	}
	
	//Actions and Filters
		if (isset($Plum_Code_Box)) {
			//Activation
				register_activation_hook(__FILE__, array(&$Plum_Code_Box, 'activate'));
				
				$url = get_bloginfo('wpurl') . '/wp-content/plugins/plum-code-box';
				wp_register_script('chili', $url.'/chili/jquery.chili-2.2.js', array( 'jquery' ), '2.2');
				wp_enqueue_script('chili');
				wp_register_script('chili_recipes', $url.'/chili/recipes.js', array( 'chili' ), '2.2');
				wp_enqueue_script('chili_recipes');
				
			//Post Meta Forms
				add_action('add_meta_boxes', array(&$Plum_Code_Box, 'add_post_meta_boxes'));
				add_action('save_post', array(&$Plum_Code_Box, 'save_post_meta_boxes'));
			
			//Filters
				add_filter('the_content', array(&$Plum_Code_Box, 'insert_code'));
		}
?>
